#define FELLOWTRAVEL_NO			0
#define FELLOWTRAVEL_CAPTIVE	1
#define FELLOWTRAVEL_PASSENGER	2
#define FELLOWTRAVEL_OFFICER	3
#define FELLOWTRAVEL_COMPANION	4

#define EVENT_CHANGE_OFFICERS	"EvntChangeOfficers"
#define EVENT_CHANGE_COMPANIONS	"EvntChangeCompanions"

#define MAX_ITEM_TAKE	5000

#define MSGICON_ACTIVE_TIME 10
#define MSGICON_LEVELUP	0
#define MSGICON_LOGBOOK	1
#define MSGICON_GETITEM	2
//
//bool bShowSkillExpLog = false;

#event_handler("evnt_MsgIconTick","proc_MsgIconTick");

bool GetShipRemovable(ref _refCharacter)
{
	if( CheckAttribute(_refCharacter,"ShipRemovable") && sti(_refCharacter.ShipRemovable)==false ) return false;
	return true;
}

void SetShipRemovable(ref _refCharacter, bool bRemovable)
{
	if(bRemovable) DeleteAttribute(_refCharacter,"ShipRemovable");
	else _refCharacter.ShipRemovable = false;
}

//
bool CharacterIsDead(ref _refCharacter)
{
	return LAi_IsDead(_refCharacter);
}

bool IsCompanion(ref _refCharacter)
{
	int findIdx = sti(_refCharacter.index);
	ref mc = GetMainCharacter();
	for(int i=0; i<4; i++)
	{
		if(GetCompanionIndex(mc,i)==findIdx) return true;
	}
	return false;
}

bool IsOfficer(ref _refCharacter)
{
	int findIdx = sti(_refCharacter.index);
	ref mc = GetMainCharacter();
	for(int i=0; i<4; i++)
	{
		if(GetOfficersIndex(mc,i)==findIdx) return true;
	}
	return false;
}

// Viper - CharSheetEnh Start
bool IsOfficerCompanion(ref _refCharacter)
{
	int findIdx = sti(_refCharacter.index);
	ref mc = GetMainCharacter();
	int ci, cn;
	ref npc;
	for(int i=1; i<4; i++)
	{
		ci = GetCompanionIndex(mc,i);
		npc = GetCharacter(ci);
		for(int j=1; j<4; j++)
		{
			if(GetOfficersIndex(npc,j)==findIdx) return true;
		}
	}
	return false;
}
// Viper - CharSheetEnh End

void SetCharacterRemovable(ref _refCharacter,bool removable)
{
	if(removable) DeleteAttribute(_refCharacter,"NonRemovable");
	else _refCharacter.NonRemovable = true;
}

bool GetRemovable(ref _refCharacter)
{
	if( CheckAttribute(_refCharacter,"NonRemovable") ) return !sti(_refCharacter.NonRemovable);
	return true;
}

// Cargo utilites
//------------------------------------------
int GetCargoLoad(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Cargo.Load")) return 0;
	return sti(_refCharacter.Ship.Cargo.Load);
}

int RecalculateCargoLoad(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Cargo.Load")) return 0;
	int loadSpace = 0;
	for(int i=0; i<GOODS_QUANTITY; i++)
	{
		loadSpace = loadSpace + GetGoodWeightByType(i,GetCargoGoods(_refCharacter,i));
	}
	_refCharacter.Ship.Cargo.Load = loadSpace;
	return loadSpace;
}

int GetCargoFreeSpace(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Cargo.Load")) return 0;
	int freeSpace = GetCargoMaxSpace(&_refCharacter) - GetCargoLoad(_refCharacter);
	return freeSpace;
}

int GetCargoMaxSpace(ref _refCharacter)
{
	if( !CheckAttribute(_refCharacter,"Ship.Type") ) return 0;
	int _ShipType = sti(_refCharacter.Ship.Type);
	if( _ShipType==SHIP_NOTUSED )
		return 0;
	return sti(ShipsTypes[_ShipType].Capacity);
}

int GetCharacterFreeSpace(ref _refCharacter,int _Goods)
{
	int weight = sti(Goods[_Goods].weight);
	int unitQ = sti(Goods[_Goods].Units);

	int retVal = unitQ * (GetCargoFreeSpace(&_refCharacter)/weight);
	return retVal;
}

int GetSquadronFreeSpace(ref _refCharacter,int _Goods)
{
	int weight = sti(Goods[_Goods].weight);
	int unitQ = sti(Goods[_Goods].Units);

	int retVal = unitQ * (GetCargoFreeSpace(&_refCharacter)/weight);
	int i,cn;
	for(i=1; i<4; i++)
	{
		cn = GetCompanionIndex(&_refCharacter,i);
		if(cn!=-1)
		{
			
			retVal = retVal + unitQ*(GetCargoFreeSpace(&Characters[cn])/weight);
		}
	}
	return retVal;
}

int GetCargoGoods(ref _refCharacter,int _Goods)
{
	string goodsName = Goods[_Goods].name;
	if(!CheckAttribute(_refCharacter,"Ship.Cargo.Goods."+goodsName))
		return 0;
	return sti(_refCharacter.Ship.Cargo.Goods.(goodsName));
}

int GetSquadronGoods(ref _refCharacter,int _Goods)
{
	int i,cn;
	int retVal = GetCargoGoods(&_refCharacter,_Goods);
	for(i=1; i<4; i++)
	{
		cn = GetCompanionIndex(&_refCharacter,i);
		if(cn!=-1)
		{
			retVal = retVal + GetCargoGoods(&Characters[cn],_Goods);
		}
	}
	return retVal;
}

void SetCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	string goodsName = Goods[_Goods].name;
	_refCharacter.Ship.Cargo.Goods.(goodsName) = _Quantity;
	int curLoad = RecalculateCargoLoad(_refCharacter);
	int maxLoad = GetCargoMaxSpace(_refCharacter);
	if(curLoad>maxLoad)
	{
		Trace("ERROR! Cargo space overup (character=" + _refCharacter.id + ", Goods " + goodsName + " Quantity=" + _Quantity + ")");
	}
}

int AddCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	int i,cn,freeQuantity;
	string goodsName = Goods[_Goods].name;

	for(i=0; i<4; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn!=-1)
		{
			freeQuantity = GetGoodQuantityByWeight( _Goods, GetCargoFreeSpace(&Characters[cn]) );
			if(freeQuantity>=_Quantity)
			{
				Characters[cn].Ship.Cargo.Goods.(goodsName) = sti(Characters[cn].Ship.Cargo.Goods.(goodsName)) + _Quantity;
				RecalculateCargoLoad(&Characters[cn]);
				return true;
			}
			Characters[cn].Ship.Cargo.Goods.(goodsName) = sti(Characters[cn].Ship.Cargo.Goods.(goodsName)) + freeQuantity;
			_Quantity = _Quantity - freeQuantity;
			RecalculateCargoLoad(&Characters[cn]);
		}
	}
	Trace("Overup cargo space on "+_Quantity);
	return false;
}

void AddAmmoGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	string goodsName = Goods[_Goods].name;
	int oldQ = 0;
	if( CheckAttribute(_refCharacter,"Ship.Cargo.Goods."+goodsName) ) {
		oldQ = sti(_refCharacter.Ship.Cargo.Goods.(goodsName));
	}
	int newQ = oldQ + _Quantity;
	int delta = newQ/20 - oldQ/20;
	if( delta==0) return;
	int nCargoLoad = 0;
	if( CheckAttribute(_refCharacter, "Ship.Cargo.Load") ) {
		nCargoLoad = sti(_refCharacter.Ship.Cargo.Load);
	}
	_refCharacter.Ship.Cargo.Load = nCargoLoad + delta*sti(Goods[_Goods].Weight);
}

int RemoveCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	int i,cn,curQuantity;
	string goodsName = Goods[_Goods].name;

	for(i=0; i<4; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn!=-1)
		{
			curQuantity = sti( Characters[cn].Ship.Cargo.Goods.(goodsName) );
			if(curQuantity>=_Quantity)
			{
				Characters[cn].Ship.Cargo.Goods.(goodsName) = curQuantity - _Quantity;
				RecalculateCargoLoad(&Characters[cn]);
				return true;
			}
			Characters[cn].Ship.Cargo.Goods.(goodsName) = 0;
			_Quantity = _Quantity - curQuantity;
			RecalculateCargoLoad(&Characters[cn]);
		}
	}
	Trace("Overup cargo space on "+_Quantity);
	return false;
}
//navy -->
int RemoveThisCharacterGoods(ref _refCharacter,int _Goods,int _Quantity)
{
	int i,curQuantity;
	string goodsName = Goods[_Goods].name;

	curQuantity = sti( _refCharacter.Ship.Cargo.Goods.(goodsName) );
	if(curQuantity>=_Quantity)
	{
		_refCharacter.Ship.Cargo.Goods.(goodsName) = curQuantity - _Quantity;
		RecalculateCargoLoad(_refCharacter);
		return true;
	}
	_refCharacter.Ship.Cargo.Goods.(goodsName) = 0;
	_Quantity = _Quantity - curQuantity;
	RecalculateCargoLoad(_refCharacter);
	Trace("Overup cargo space on "+_Quantity);
	return false;
}
//navy <--
// Cannons utilite
int GetCaracterShipCannonsType(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Cannons.Type")) return CANNON_TYPE_NONECANNON;
	return sti(_refCharacter.Ship.Cannons.Type);
}
int GetCannonQuantity(ref refCharacter)
{
	int nShipType = GetCharacterShipType(refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	ref rShip = GetShipByType(nShipType);
	return sti(rShip.CannonsQuantity);
}
int GetMaximumCaliber(ref refCharacter)
{
	int nShipType = GetCharacterShipType(refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	ref rShip = GetShipByType(nShipType);
	return sti(rShip.MaxCaliber);
}

//navy --> 18.06.05
string Navy_GetCannonName(int ct)
{
	if(ct==CANNON_TYPE_NONECANNON)	return XI_ConvertString("NoneCannons");
	ref cref = GetCannonByType(ct);
	string cname;
	if(cref.type==CANNON_NAME_CULVERINE)	cname = XI_ConvertString("Culverine");
	else	cname = XI_ConvertString("Cannon");
	string retVal = cref.caliber + "" + " " + cname;
	return retVal;
}
//navy <-- 18.06.05
// Ship utilite
int GetCharacterShipType(ref _refCharacter)
{
	if(CheckAttribute(_refCharacter,"Ship.Type"))
	{
		int iShipType = sti(_refCharacter.Ship.Type);
		if(iShipType>=0 && iShipType<SHIP_TYPES_QUANTITY_WITH_FORT)	return iShipType;
	}
	return SHIP_NOTUSED;
}
int GetCharacterShipHP(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	return sti(ShipsTypes[nShipType].HP);
}
int GetCurrentShipHP(ref _refCharacter)
{
	if( CheckAttribute(_refCharacter,"ship.hp") ) return sti(_refCharacter.ship.hp);
	return 0;
}
int GetCharacterShipSP(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if(nShipType==SHIP_NOTUSED) return 0;
	return sti(ShipsTypes[nShipType].SP);
}
string GetShipTypeName(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if(nShipType==SHIP_NOTUSED) return SHIP_NOTUSED_TYPE_NAME;
	return ShipsTypes[nShipType].Name;
}
int GetCharacterShipClass(ref _refCharacter)
{
	int nShipType = GetCharacterShipType(_refCharacter);
	if( nShipType==SHIP_NOTUSED ) return -1;
	return sti(ShipsTypes[nShipType].Class);
}
int GetMaxCrewQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Type")) return 0;
	int shipType = sti(_refCharacter.Ship.Type);
	if(shipType<0) return 0;
	if(shipType>=SHIP_TYPES_QUANTITY) return 0;
	return sti(ShipsTypes[shipType].MaxCrew);
}
int GetMinCrewQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Type")) return 0;
	int shipType = sti(_refCharacter.Ship.Type);
	if(shipType<0) return 0;
	if(shipType>=SHIP_TYPES_QUANTITY) return 0;
	return sti(ShipsTypes[shipType].MinCrew);
}
int GetFreeCrewQuantity(ref _refCharacter)
{
	return (GetMaxCrewQuantity(_refCharacter)-GetCrewQuantity(_refCharacter));
}
int GetFreePartyCrewQuantity(ref _refCharacter)
{
	int cn;
	int sumCrew = 0;
	for(int i=0; i<4; i++)
	{
		cn = GetCompanionIndex(_refCharacter,i);
		if(cn!=-1)
		{
			sumCrew = sumCrew + GetFreeCrewQuantity(GetCharacter(cn));
		}
	}
	return sumCrew;
}
int GetCrewQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.Crew.Quantity")) return 0;
	return sti(_refCharacter.Ship.Crew.Quantity);
}
int SetCrewQuantity(ref _refCharacter,int num)
{
	int maxCrew = GetMaxCrewQuantity(_refCharacter);
	if(num>maxCrew)
	{
		Trace("Error!!! Overup maximum crew quantity (character=" + _refCharacter.index + ")");
		_refCharacter.Ship.Crew.Quantity = maxCrew;
		return false;
	}
	_refCharacter.Ship.Crew.Quantity = num;
	return true;
}
int AddCharacterCrew(ref _refCharacter,int num)
{
	return SetCrewQuantity(_refCharacter,GetCrewQuantity(_refCharacter)+num);
}
int RemoveCharacterCrew(ref _refCharacter,int num)
{
	int curCrew = GetCrewQuantity(_refCharacter);
	if(curCrew<num)
	{
		Trace("Error!!! Remove overup crew (character=" + _refCharacter.index + ")");
		SetCrewQuantity(_refCharacter,0);
		return false;
	}
	SetCrewQuantity(_refCharacter,curCrew-num);
	return true;
}
float GetSailPercent(ref _refCharacter)
{
	if( !CheckAttribute(_refCharacter,"Ship.SP") ) return 100.0;
	int iSP = GetCharacterShipSP(_refCharacter);
	if(iSP<=0) return 100.0;
	float fpsp = 100.0*stf(_refCharacter.Ship.SP)/iSP;
	return fpsp;
}
float GetHullPercent(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Ship.HP")) return 100.0;
	int iHP = GetCharacterShipHP(_refCharacter);
	if(iHP<=0) return 100.0;
	float fphp = 100.0*stf(_refCharacter.Ship.HP)/iHP;
	return fphp;
}
float GetSailRPD(ref _refCharacter) //     
{
	int repairSkill = GetSummonSkillFromName(_refCharacter,SKILL_REPAIR);
	float damagePercent = 100.0 - GetSailPercent(_refCharacter);
	if(damagePercent==0.0) return 0.0;
	return repairSkill*10.0 / damagePercent;
}
float GetHullRPD(ref _refCharacter) //     
{
	int repairSkill = GetSummonSkillFromName(_refCharacter,SKILL_REPAIR);
	float damagePercent = 100.0 - GetHullPercent(_refCharacter);
	if(damagePercent==0.0) return 0.0;
	return repairSkill*10.0 / damagePercent;
}
int GetSailSPP(ref _refCharacter) //      
{
	return 8-GetCharacterShipClass(_refCharacter);
}
int GetHullPPP(ref _refCharacter) //      
{
	return 8-GetCharacterShipClass(_refCharacter);
}

// Fellowtravels utilites
//   
bool IsPassenger(ref _refCharacter)
{
	ref mc;
	mc = GetMainCharacter();
	int PsgQ = GetPassengersQuantity(mc);
	for(int i=0; i<PsgQ; i++)
	{
		if(GetPassenger(mc, i) == sti(_refCharacter.index)) return true;
	}
	return false;
}

int GetPassengersQuantity(ref _refCharacter)
{
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Quantity")) return 0;
	return sti(_refCharacter.Fellows.Passengers.Quantity);
}
int GetPassenger(ref _refCharacter,int idx)
{
	if(idx<0) return -1;
	if(idx>=GetPassengersQuantity(_refCharacter)) return -1;

	string PsgAttrName = "id"+(idx+1);
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers."+PsgAttrName)) return -1;
	return sti(_refCharacter.Fellows.Passengers.(PsgAttrName));
}
int GetPassengerNumber(ref _refCharacter,int findCharacterIdx)
{
	int psgQuant = GetPassengersQuantity(_refCharacter);
	int cn;
	ref cr;
	for(int i=0; i<psgQuant; i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;
		cr = GetCharacter(cn);
		if(findCharacterIdx==sti(cr.index)) return i;
	}
	return -1;
}
int GetNotCaptivePassenger(ref _refCharacter,int idx)
{
	if(idx<0) return -1;
	int psgQuant = GetPassengersQuantity(_refCharacter);

	int curIdx=0;
	ref curChar;
	int cn;
	for(int i=0;i<psgQuant;i++)
	{
		cn = GetPassenger(_refCharacter,i);
		if(cn==-1) break;

		curChar = GetCharacter(cn);
		if(CheckAttribute(curChar,"prisoned"))
		{
			if(sti(curChar.prisoned)==true) continue;
		}
		if(curIdx==idx)	return sti(curChar.index);
		curIdx++;
	}
	return -1;
}
int ChangePassenger(ref _refCharacter,int idx, int psngIdx)
{
	int retVal = GetPassenger(&_refCharacter,idx);
	if(idx>=0)
	{
		string PsgAttrName = "id"+(idx+1);
		_refCharacter.Fellows.Passengers.(PsgAttrName) = psngIdx;
	}
	return retVal;
}
int AddPassenger(ref _refCharacter,ref _refPassenger, int prisonFlag)
{
	int PsgQuantity = GetPassengersQuantity(_refCharacter);
	if(PsgQuantity<PASSENGERS_MAX)
	{
		aref tmpRef; makearef(tmpRef,_refCharacter.Fellows.Passengers);
		string PsgAttrName;
		for(int i=0;i<PsgQuantity;i++)
		{
			PsgAttrName = "id"+(i+1);
			if(tmpRef.(PsgAttrName)==_refPassenger.index) return PsgQuantity;
		}
		PsgQuantity++;
		tmpRef.Quantity = PsgQuantity;
		PsgAttrName = "id"+PsgQuantity;
		tmpRef.(PsgAttrName) = _refPassenger.index;
		if(prisonFlag==true)	_refPassenger.prisoned = true;
	}
	else	trace("Overup maximum passengers quantity");
	return PsgQuantity;
}
int RemovePassenger(ref _refCharacter,ref _refPassenger)
{
	RemoveOfficersIndex(_refCharacter,sti(_refPassenger.index));
	int PsgQuantity = GetPassengersQuantity(_refCharacter);
	int psgNum = GetPassengerNumber(_refCharacter,sti(_refPassenger.index));
	if(psgNum==-1) return PsgQuantity;

	aref tmpRef;
	makearef(tmpRef,_refCharacter.Fellows.Passengers);
	string inPsgAttrName,outPsgAttrName;
	for(int i=(psgNum+1); i<PsgQuantity; i++)
	{
		inPsgAttrName = "id"+i;
		outPsgAttrName = "id"+(i+1);
		tmpRef.(inPsgAttrName) = tmpRef.(outPsgAttrName);
	}

	outPsgAttrName = "id"+PsgQuantity;
	DeleteAttribute(tmpRef,outPsgAttrName);
	PsgQuantity--;
	tmpRef.Quantity = PsgQuantity;
	return PsgQuantity;
}
//navy --> 
int FindPassengerTeacher(ref _refCharacter)
{
	int PsgQ, ci;
	ref chr;
		
	PsgQ = GetPassengersQuantity(_refCharacter);
	for(int i=0; i<PsgQ; i++)
	{
		ci = GetPassenger(_refCharacter, i);
		if(ci == -1) continue;
		chr = GetCharacter(ci);
		if(CheckAttribute(chr, "quest.officertype") && chr.quest.officertype == OFFIC_TYPE_TEACHER) return ci;
	}
	return -1;
}
//navy <-- 

int FindFellowtravellers(ref _refCharacter,ref _refFindCharacter)
{
	int i;
	string stmp;
	aref atmp;
	aref curref;

	if(sti(_refFindCharacter.index)==-1) return FELLOWTRAVEL_NO;
	if(CheckAttribute(_refFindCharacter,"prisoned"))
	{
		if(sti(_refFindCharacter.prisoned)==true) return FELLOWTRAVEL_CAPTIVE;
	}
	for(i=1;i<4;i++)
	{
		if( sti(_refFindCharacter.index) == GetOfficersIndex(_refCharacter,i) )	return FELLOWTRAVEL_OFFICER;
	}
	for(i=0;i<GetPassengersQuantity(_refCharacter);i++)
	{
		if(sti(_refFindCharacter.index)==GetPassenger(_refCharacter,i))	return FELLOWTRAVEL_PASSENGER;
	}
	for(i=1;i<4;i++)
	{
		if( GetCompanionIndex(_refCharacter,i)==sti(_refFindCharacter.index) )	return FELLOWTRAVEL_COMPANION;
	}
	return FELLOWTRAVEL_NO;
}

//   
int SetCompanionIndex(ref _refCharacter,int _CompanionNum, int _CompanionIdx)
{
    if(_CompanionNum == -1)
	{
		for(int i=1; i<4; i++)	
		{
			if (GetCompanionIndex(_refCharacter, i) == -1)
			{
				_CompanionNum = i;
				break;
			}
		}
	}
	if(_CompanionNum<1) return _CompanionIdx;
	if(_CompanionNum>3) return _CompanionIdx;

	if(_CompanionIdx!=-1)
	{
		for(i=0;i<4;i++)
		{
			if(GetCompanionIndex(_refCharacter,i)==_CompanionIdx) return -1;
		}
	}

	string compName = "id"+_CompanionNum;
	int retVal = GetCompanionIndex(_refCharacter,_CompanionNum);
	_refCharacter.Fellows.Companions.(compName) = _CompanionIdx;

	if( _CompanionIdx>=0 && CheckAttribute(&Characters[_CompanionIdx],"nation") ) {
		Characters[_CompanionIdx].prev_nation = Characters[_CompanionIdx].nation;
		Characters[_CompanionIdx].nation = _refCharacter.nation;
	}
	if( retVal>=0 && CheckAttribute(&Characters[retVal],"prev_nation") ) {
		Characters[retVal].nation = Characters[retVal].prev_nation;
	}

	Event(EVENT_CHANGE_COMPANIONS,"");
	return retVal;
}
int RemoveCharacterCompanion(ref _refCharacter, ref refCompanion)
{
	string compName;
	int i;

	aref refComps;
	makearef(refComps,_refCharacter.Fellows.Companions);
	for(i=1; i<4; i++)
	{
		compName = "id"+i;
		if(CheckAttribute(refComps,compName) && refComps.(compName)==refCompanion.index)
		{
			refComps.(compName) = -1;
			refCompanion.location = _refCharacter.location;
			refCompanion.location.group = _refCharacter.location.group;
			refCompanion.location.locator = _refCharacter.location.locator;
			Event(EVENT_CHANGE_COMPANIONS,"");
			return i;
		}
	}
	return -1;
}

int GetCompanionIndex(ref _refCharacter,int _CompanionNum)
{
	if(_CompanionNum<0) return -1;
	if(_CompanionNum>3) return -1;
	if(_CompanionNum==0) return sti(_refCharacter.index);

	string compName = "id"+_CompanionNum;
	if(!CheckAttribute(_refCharacter,"Fellows.Companions."+compName)) return -1;
	return sti(_refCharacter.Fellows.Companions.(compName));
}
int GetCompanionNumber(ref _refCharacter,int _CompanionIdx)
{
	for(int i=0; i<4; i++)
	{
		if( GetCompanionIndex(_refCharacter,i) == _CompanionIdx ) return i;
	}
	return -1;
}
int GetCompanionQuantity(ref _refCharacter)
{
	int qn = 1;
	for(int i=1; i<4; i++)
	{
		if( GetCompanionIndex(_refCharacter,i)>=0 ) qn++;
	}
	return qn;
}

//   
int GetOfficersQuantity(ref _refCharacter)
{
	int idx=0;
	for(int i=1; i<4; i++)
	{
		if( GetOfficersIndex(_refCharacter,i)!=-1 ) idx++;
	}
	return idx;
}
//navy --> 31.05.05
int FindNextOfficerIndex(ref _refCharacter,int _OfficerNum, bool bRight)
{
	int i, retVal;
	if(bRight)
	{
		for(i=_OfficerNum; i<4; i++)
		{
			retVal = GetOfficersIndex(_refCharacter, i);
			if(retVal!=-1) return retVal;
		}
	}
	else
	{
		for(i=_OfficerNum; i==0; i--)
		{
			retVal = GetOfficersIndex(_refCharacter, i);
			if(retVal!=-1) return retVal;
		}
	}
	return -1;
}
//navy <-- 31.05.05
int GetOfficersIndex(ref _refCharacter,int _OfficerNum)
{
	if(_OfficerNum<0) return -1;
	if(_OfficerNum>3) return -1;
	if(_OfficerNum==0) return MakeInt(_refCharacter.index);

	string compName = "id"+_OfficerNum;
	if(!CheckAttribute(_refCharacter,"Fellows.Passengers.Officers."+compName)) return -1;
	return sti(_refCharacter.Fellows.Passengers.Officers.(compName));
}
int SetOfficersIndex(ref _refCharacter,int _OfficerNum, int _OfficerIdx)
{
	int i;
    if(_OfficerNum == -1)
	{
		for(i=1; i<4; i++)	
		{
			if(GetOfficersIndex(_refCharacter, i) == -1)
			{
				_OfficerNum = i;
				break;
			}
		}
	}
	if(_OfficerNum == -1) _OfficerNum = 3;
	if(_OfficerNum<1) return _OfficerIdx;
	if(_OfficerNum>3) return _OfficerIdx;

	if(_OfficerIdx!=-1)
	{
		for(i=0;i<4;i++)
		{
			if(GetOfficersIndex(_refCharacter,i)==_OfficerIdx) return -1;
		}
		AddPassenger(_refCharacter,GetCharacter(_OfficerIdx),false);
	}

	string compName = "id"+_OfficerNum;
	int retVal = GetOfficersIndex(_refCharacter,_OfficerNum);
	_refCharacter.Fellows.Passengers.Officers.(compName) = _OfficerIdx;
	if(_OfficerIdx>=0)
	{
		LAi_SetOfficerType(GetCharacter(_OfficerIdx));
		Characters[_OfficerIdx].location = _refCharacter.location;
	}
	if(retVal>=0)
	{
		LAi_SetCitizenTypeNoGroup(GetCharacter(retVal));
		Characters[retVal].location = "none";
	}
	Event(EVENT_CHANGE_OFFICERS,"");
	return retVal;
}
bool RemoveOfficersIndex(ref _refCharacter, int _OfficerIdx)
{
	if(_OfficerIdx==-1) return false;
	for(int i=1; i<4; i++)
	{
		if(GetOfficersIndex(_refCharacter,i) == _OfficerIdx)
		{
			SetOfficersIndex(_refCharacter,i,-1);
			return true;
		}
	}
	return false;
}

// table service
string GetReputationName(int reputation)
{
    if(reputation<11)
        return ReputationTable[REPUTATIONT_HORROR];
    if(reputation<21)
        return ReputationTable[REPUTATIONT_BASTARD];
    if(reputation<31)
        return ReputationTable[REPUTATIONT_SWINDLER];
    if(reputation<41)
        return ReputationTable[REPUTATIONT_RASCAL];
    if(reputation<51)
        return ReputationTable[REPUTATIONT_NEUTRAL];
    if(reputation<61)
        return ReputationTable[REPUTATIONT_PLAIN];
    if(reputation<71)
        return ReputationTable[REPUTATIONT_GOOD];
    if(reputation<81)
        return ReputationTable[REPUTATIONT_VERYGOOD];
    if(reputation<90)
        return ReputationTable[REPUTATIONT_HERO];
	return "";
}

string GetMoraleName(int morale)
{
	if(morale<10)
		return MoraleTable[MORALET_TREACHEROUS];
	if(morale<20)
		return MoraleTable[MORALET_AWFUL];
	if(morale<30)
		return MoraleTable[MORALET_LOW];
	if(morale<40)
		return MoraleTable[MORALET_POOR];
	if(morale<50)
		return MoraleTable[MORALET_NORMAL];
	if(morale<60)
		return MoraleTable[MORALET_ELATED];
	if(morale<70)
		return MoraleTable[MORALET_GOOD];
	if(morale<80)
		return MoraleTable[MORALET_HIGH];
	if(morale<90)
		return MoraleTable[MORALET_EXCELLENT];
	if(morale<100)
		return MoraleTable[MORALET_HEROIC];
	return "";
}

//navy --> 12.06.05
string GetCrewStatusName(int _exp)
{
	if(_exp<1000) 
		return CREW_YOUNGSTERS;
	if(_exp<2000)
		return CREW_SEAMEN;
	if(_exp<3000)
		return CREW_SEAWOLVES;
}
//navy <-- 12.06.05

// skill and expirence service
string GetSkillName(int _SkillType)
{
	switch(_SkillType)
	{
	case 0:
		return SKILL_LEADERSHIP;
		break;
	case 1:
		return SKILL_FENCING;
		break;
	case 2:
		return SKILL_SAILING;
		break;
	case 3:
		return SKILL_ACCURACY;
		break;
	case 4:
		return SKILL_CANNONS;
		break;
	case 5:
		return SKILL_GRAPPLING;
		break;
	case 6:
		return SKILL_REPAIR;
		break;
	case 7:
		return SKILL_DEFENCE;
		break;
	case 8:
		return SKILL_COMMERCE;
		break;
	case 9:
		return SKILL_SNEAK;
		break;
	}
	return "";
}
//navy -->
int GetRequiredSailing(ref ch, int iShipClass)
{
	//TODO:   .
	int retVal;
	switch(iShipClass)
	{
	case 5:
		retVal = 3;
		break;
	case 4:
		retVal = 5;
		break;
	case 3:
		retVal = 7;
		break;
	case 2:
		retVal = 9;
		break;
	case 1:
		retVal = 10;
		break;
		retVal = 1;
	}
	return retVal;
}

int GetAvailableShipClass(int skillSailing)
{
	int retVal = 7;
	if (skillSailing > 0) retVal = 6;
	if (skillSailing > 2) retVal = 5;
	if (skillSailing > 4) retVal = 4;
	if (skillSailing > 6) retVal = 3;
	if (skillSailing > 8) retVal = 2;
	if (skillSailing == 10) retVal = 1;

	return retVal;
}

int GetSummonSkillFromName(ref _refCharacter, string skillName)
{
	int iShipClass, SailingSkill, sumSkill, reqSailing;
	
	iShipClass = GetCharacterShipClass(_refCharacter);
	SailingSkill = GetSummonSkillFromNameEx(_refCharacter, SKILL_SAILING);
	sumSkill = GetSummonSkillFromNameEx(_refCharacter, skillName);

	if(iShipClass!=-1)
	{
		reqSailing = GetRequiredSailing(_refCharacter, iShipClass);
		if(reqSailing > SailingSkill && sumSkill != 0)
			sumSkill += (SailingSkill - reqSailing);
		if(sumSkill < 1) sumSkill = 1;
	}
	return sumSkill;
}

int ItemModifyCharacterSkill(ref ch, string skillName, string item, string itemSkill, int value)
{
	int skillVal = sti(ch.skill.(skillName));
	if(skillName == itemSkill && GetCharacterItem(ch, item) > 0 && skillVal < SKILL_MAX) return value;
	return 0;
}
//navy <--
int GetCharacterSkill(ref _refCharacter, string skillName)
{
	if( !CheckAttribute(_refCharacter,"Skill."+skillName) || _refCharacter.Skill.(skillName) == "0") return 0;
	int skillN = sti(_refCharacter.Skill.(skillName));
	// boal   -->
	//   +1 
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "jewelry9", SKILL_SNEAK, 1);
	// itmname_CursedCoin		{ } -1 
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "CursedCoin", SKILL_SNEAK, -1);
	// Emerald Pendant +1 
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "jewelry15", SKILL_SNEAK, 1);
	// Pikachuatl Idol +1 
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "indian7", SKILL_SNEAK, 1);
	// itmname_jewelry8	{Bronze Ring} +1 
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "jewelry8", SKILL_SNEAK, 1);
	// Weird Animal Figurine (-1 )
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "indian2", SKILL_LEADERSHIP, -1);
	// itmname_jewelry4	{} (+1 )
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "jewelry4", SKILL_LEADERSHIP, 1);
	// Small Mosaic (+1 )
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "indian3", SKILL_COMMERCE, 1);
	// indian6	{ } (+1 )
	skillN += ItemModifyCharacterSkill(_refCharacter, skillName, "indian6", SKILL_FENCING, 1);
	// boal <--

	//navy -->  
	if (CheckAttribute(_refCharacter, "chr_ai.drunk.skill." + skillName)) 
	{
		skillN += sti(_refCharacter.chr_ai.drunk.skill.(skillName));
	}
	//<--

	if(skillN < 1) return 1; //navy fix
	if( skillN <= SKILL_MAX ) return skillN;
	trace("Character ID = "+_refCharacter.id + "have skill "+skillName + " = "+skillN);
	return SKILL_MAX;
}

int GetSummonSkillFromNameEx(ref _refCharacter, string skillName)
{
	int sumSkill = GetCharacterSkill(_refCharacter,skillName);
	int i,cn,curSkill;
	for(i=1;i<4;i++)
	{
		cn = GetOfficersIndex(&_refCharacter,i);
		if(cn!=-1)
		{
			curSkill = GetCharacterSkill(GetCharacter(cn),skillName);
			if(sumSkill<curSkill)
			{
				sumSkill = curSkill;
			}
		}
	}
	return sumSkill;
}

int GetSummonSkill(ref _refCharacter,int _SkillType)
{
	return GetSummonSkillFromName(&_refCharacter,GetSkillName(_SkillType));
}

string GetBasicSkill(ref _refCharacter)
{
	aref refSkill;
	makearef(refSkill,_refCharacter.Skill);
	string skillName;

	int i=0;
	int maxSkillValue = -1;
	string maxSkillName;
	for(i=0; i<15; i++)
	{
		skillName = GetSkillName(i);
		if(MakeInt(refSkill.(skillName))>maxSkillValue)
		{
			maxSkillName = skillName;
			maxSkillValue = MakeInt(refSkill.(skillName));
		}
	}
	return maxSkillName;
}

void AddPartyExp(ref _refCharacter,int _exp)
{
	int cn,i;
	ref chref;
	i = GetOfficersQuantity(_refCharacter);
	_exp = (_exp+i)/(i+1);
	for(i=0; i<4; i++)
	{
		cn = GetOfficersIndex(_refCharacter,i);
		if(cn!=-1)
		{	AddCharacterExp(GetCharacter(cn),_exp);
		}
	}
}

void AddExpAndShow(ref chref, int _exp)
{
	Log_SetStringToLog("+" + _exp + XI_ConvertString("add experience"));
	AddCharacterExp(chref, _exp);
}

//navy --> 29/05/05
void AddCharacterExpToSkill(ref _refCh, string _Skill, float _exp)
{
	int nextLevel, lSkill, nSkill1, nSkill2;
	float SumExp;
	float kExp = 1.0;
	lSkill = sti(_refCh.skill.(_Skill));

	//if (bShowSkillExpLog)
	//{
	//	Log_Info("Char: " + _refCh.Name + " get Exp: " + _exp + " to Skill: " + _Skill);
	//}
	if (FindPassengerTeacher(_refCh) != -1) kExp = 1.2;
	trace("Char: " + _refCh.Name + " get Exp: " + _exp + " to Skill: " + _Skill);
	//      , 
	if(lSkill >= SKILL_MAX || lSkill <= 0) return;
	if(bTestMode) kExp=1.0;
	SumExp = stf(_refCh.progress.(_Skill)) + _exp*kExp;
	_refCh.progress.(_Skill) = SumExp;
	nextLevel = CalculateExpForCharSkill(_refCh, _Skill, lSkill+1);
	while(SumExp>=nextLevel)
	{
		_refCh.skill.(_Skill)= lSkill+1;
	
		lSkill = sti(_refCh.skill.(_Skill));
		nextLevel = CalculateExpForCharSkill(_refCh, _Skill, lSkill+1);
		DebugTrace("~~~ SumExp " + SumExp + " nextLevel " + nextLevel + " SkillLevel " + lSkill);

		if(_refCh.id==GetMainCharacterId()) 
			Log_SetStringToLog(XI_ConvertString(_Skill) + " UP!");
		if(_Skill==SKILL_LEADERSHIP || _Skill==SKILL_FENCING || _Skill==SKILL_GUN || _Skill==SKILL_COMMERCE || _Skill==SKILL_SNEAK)
            _refCh.skill.freeskill = sti(_refCh.skill.freeskill)+1;
		else _refCh.skill.freeskil2 = sti(_refCh.skill.freeskil2)+1;
		
		nSkill1 = sti(_refCh.skill.freeskill);
		nSkill2 = sti(_refCh.skill.freeskil2);
		if((nSkill1+nSkill2) == 2) 
		{
			_refCh.rank = sti(_refCh.rank)+1;
			float mhp = LAi_GetCharacterMaxHP(_refCh) + 5.0;
			LAi_SetHP(_refCh,mhp,mhp);
			if (IsOfficer(_refCh) || IsCompanion(_refCh))
			{
				AddMsgToCharacter(_refCh,MSGICON_LEVELUP);
				Log_SetStringToLog(" !");
				PlayStereoSound("interface\new_level.wav");
			}
		}
		if (nSkill1 == 2) 
		{
			_refCh.skill.freeskill = 0;
			if (CheckAttribute(_refCh,"perks.freepoints")) 
				_refCh.perks.freepoints = sti(_refCh.perks.freepoints) + 1;
			else 
				_refCh.perks.freepoints = 1;
		}
		if (nSkill2 == 2)
		{
			_refCh.skill.freeskil2 = 0;
			if (CheckAttribute(_refCh,"perks.freepoint2")) 
				_refCh.perks.freepoint2 = sti(_refCh.perks.freepoint2) + 1;
			else 
				_refCh.perks.freepoint2 = 1;
		}
		if(lSkill >= SKILL_MAX) break;
	}
	//   " " 
	if( CheckCharacterPerk(_refCh,"SharedExperience") )
	{
		int cn;
		for(int i=0;i<GetPassengersQuantity(_refCh);i++)
		{
			cn = GetPassenger(_refCh,i);
			if(cn!=-1)
			{
				if(IsOfficer(GetCharacter(cn)))
					AddCharacterExpToSkill(GetCharacter(cn), _Skill, (_exp+4)*0.8);
				else
					AddCharacterExpToSkill(GetCharacter(cn), _Skill, (_exp+4)*0.2);
			}
		}
	}
	//Navy_BettaTestLog("~~~ SumExp=" + SumExp + " Exp=" + _exp + "   for char " + _refCh.id + " Skill " + _Skill);
	//if(bTestMode) trace("~~~ SumExp=" + SumExp + " Exp=" + _exp + "   for char " + _refCh.id + " Skill " + _Skill);
}

void AddCharacterExpToCrew(ref _refCh, float _exp)
{
	if(!CheckAttribute(_refCh, "Crew.Exp")) _refCh.Crew.Exp = 0;
	_refCh.Crew.Exp = stf(_refCh.Crew.Exp) + _exp;
	//Navy_BettaTestLog("Crew gained exp " + _refCh.CrewExp);
}

void AddCharacterCrewMorale(ref _refCh, int _add)
{
	if( !CheckAttribute(_refCh,"Ship.Crew.Morale") ) return;
	int crewMorale = sti(_refCh.Ship.Crew.Morale);

	crewMorale += _add;
	if(crewMorale>MORALE_MAX)	crewMorale = MORALE_MAX;
	if(crewMorale<MORALE_MIN)	crewMorale = MORALE_MIN;
	_refCh.Ship.Crew.Morale = crewMorale;
}

void Navy_BettaTestLog(string stLog)
{
	if(stLog!="" && bTestMode) 
	{
		Log_SetStringToLog(stLog);
		trace("~~~ BETTA LOG ~~~ " + stLog);
	}
}
//  Log_SetStringToLog() :)
void ShowLog(string sToLog)
{
	Log_SetStringToLog(sToLog);
}
//navy <--

int AddCharacterExp(ref _refCharacter,int _exp)
{
	int retVal = false;
	trace("===  " + _exp + " ");
	AddCharacterExpToSkill(_refCharacter, SKILL_LEADERSHIP, _exp*0.01);
	return retVal;

	int curExp = sti(_refCharacter.Experience) + _exp;
	_refCharacter.Experience = curExp;
	int nextExp = CalculateExperienceFromRank(sti(_refCharacter.rank)+1);
	while(curExp>=nextExp)
	{
		_refCharacter.rank = sti(_refCharacter.rank) + 1;
		_refCharacter.Skill.FreeSkill = sti(_refCharacter.Skill.FreeSkill) + 2;
		if(CheckAttribute(_refCharacter,"perks.FreePoints"))
		{	_refCharacter.perks.FreePoints = sti(_refCharacter.perks.FreePoints) + 1;
		}
		else
		{	_refCharacter.perks.FreePoints = 1;
		}
		nextExp = CalculateExperienceFromRank(sti(_refCharacter.rank)+1);
		float mhp = LAi_GetCharacterMaxHP(_refCharacter) + 5.0;
		LAi_SetHP(_refCharacter,mhp,mhp);
		retVal = true;
		if(sti(_refCharacter.index)==GetMainCharacterIndex())
		{
			Log_SetStringToLog(XI_ConvertString(" !"));
			PlayStereoSound("interface\new_level.wav");
		}
	}
	if( CheckCharacterPerk(_refCharacter,"SharedExperience") )
	{
		int cn;
		//boal -->
        for(int i=1;i<=GetPassengersQuantity(_refCharacter);i++)
        {
           cn = GetPassenger(_refCharacter,i);
           if(cn!=-1)
           {
              if(IsOfficer(GetCharacter(cn)) || IsCompanion(GetCharacter(cn)))
              {
                AddCharacterExp(GetCharacter(cn),(_exp+4)/2);
                if (MOD_SHOWMESSAGE == "On")
                {
                    Log_SetStringToLog("   " + (_exp+4)/2);
                }
              }
              else
              { AddCharacterExp(GetCharacter(cn),(_exp+4)/5); }
           }
        }
        // boal <--
	}
	if(retVal)
	{
		if(IsOfficer(_refCharacter) || IsCompanion(_refCharacter))
		{
			AddMsgToCharacter(_refCharacter,MSGICON_LEVELUP);
//boal -->
            Log_SetStringToLog(XI_ConvertString(" !"));
			PlayStereoSound("interface\new_level.wav");
//boal <--
		}
	}
	return retVal;
}

int CalculateExperienceFromRank(int _Rank)
{
	if(_Rank<2) return 0;
	int retVal = (MakeInt(1000 * pow(_Rank-1,2.3))/1000)*1000;
	return retVal;
}

//navy --> 29/05/05
int CalculateExpForCharSkill(ref _refChar, string _SkillName, int _Level)
{
	ref rType;
	float fKRet = 1.0;
	if(_Level<2 || _Level>SKILL_MAX) return 0;
	int retVal = MakeInt(800*pow(_Level-1, 1.7));

	if(CheckAttribute(_refChar, "type"))
	{
		makeref(rType, Types[sti(_refChar.type)]);
		if(rType.main.Skill1==_SkillName) fKRet = 0.85;
		if(rType.main.Skill2==_SkillName) fKRet = 0.90;
		if(rType.main.Skill3==_SkillName) fKRet = 0.95;

		if(rType.bad.Skill1==_SkillName) fKRet = 1.15;
		if(rType.bad.Skill2==_SkillName) fKRet = 1.10;
	}

	return MakeInt(retVal*fKRet*nDifficulty);
}

void CalculateAppropriateExpToSkills(ref _refCh)
{
		_refCh.progress.Leadership = CalculateExpForCharSkill(_refCh, "Leadership", sti(_refCh.skill.Leadership));
		_refCh.progress.Fencing = CalculateExpForCharSkill(_refCh, "Fencing", sti(_refCh.skill.Fencing));
		_refCh.progress.Gun = CalculateExpForCharSkill(_refCh, "Gun", sti(_refCh.skill.Gun));
		_refCh.progress.Sailing = CalculateExpForCharSkill(_refCh, "Sailing", sti(_refCh.skill.Sailing));
		_refCh.progress.Accuracy = CalculateExpForCharSkill(_refCh, "Accuracy", sti(_refCh.skill.Accuracy));
		_refCh.progress.Cannons = CalculateExpForCharSkill(_refCh, "Cannons", sti(_refCh.skill.Cannons));
		_refCh.progress.Grappling = CalculateExpForCharSkill(_refCh, "Grappling", sti(_refCh.skill.Grappling));
		_refCh.progress.Repair = CalculateExpForCharSkill(_refCh, "Repair", sti(_refCh.skill.Repair));
		_refCh.progress.Defence = CalculateExpForCharSkill(_refCh, "Defence", sti(_refCh.skill.Defence));
		_refCh.progress.Commerce = CalculateExpForCharSkill(_refCh, "Commerce", sti(_refCh.skill.Commerce));
		_refCh.progress.Sneak = CalculateExpForCharSkill(_refCh, "Sneak", sti(_refCh.skill.Sneak));
}
//navy <-- 29/05/05

int AddMoneyToCharacter(ref _refCharacter,int _Money)
{
	int newMoney = sti(_refCharacter.Money) + _Money;
	if(newMoney<0) newMoney=0;
	_refCharacter.Money = newMoney;
	return newMoney;
}

void SetBaseShipData(ref refCharacter)
{
    int  i, n;
    aref refShip;
    int  nShipType;
    ref  refBaseShip;

	if(CheckAttribute(refCharacter,"Ship"))
	{
//navy --> 12.06.05  
		refCharacter.Crew.Exp = 0;
//navy <-- 12.06.05
		makearef(refShip,refCharacter.Ship);

		nShipType = GetCharacterShipType(refCharacter);
		if(nShipType==SHIP_NOTUSED) return;

		refBaseShip = GetShipByType(nShipType);

		refShip.HP = refBaseShip.HP;
		refShip.SP = refBaseShip.SP;

		refShip.Pos.x = 0;
		refShip.Pos.z = 0;
		refShip.Ang = "";
		refShip.Cannons.Borts = "";
		refShip.Cannons.Charge.Type = GOOD_BALLS; // boal fix 29.11.03
		if (!CheckAttribute(refShip,"Cannons.Type")) { refShip.Cannons.Type = MakeInt(refBaseShip.Cannon); }

		if (!CheckAttribute(refShip,"Crew.Morale"))	{ refShip.Crew.Morale = 45;	}
		if (!CheckAttribute(refShip,"Crew.Quantity")) { refShip.Crew.Quantity = refBaseShip.MaxCrew; }

		string goodsName;
		refCharacter.Ship.Cargo.Load = 0;
		for(i=0; i<GOODS_QUANTITY; i++)
		{
			goodsName = Goods[i].Name;
			refCharacter.Ship.Cargo.Goods.(goodsName) = 0;
		}
//navy --> 02.06.05 MOD FOR EXTENDED AMMO SUPPORT
		int shClass = GetCharacterShipClass(refCharacter);
		// bombs
		i = GetCharacterFreeSpace(refCharacter,GOOD_BOMBS);
		n = MakeInt(2400/shClass);
		if(i>0) {
			if(i>=n) SetCharacterGoods(refCharacter,GOOD_BOMBS,n);
			else SetCharacterGoods(refCharacter,GOOD_BOMBS,i);
		// grapes
			i = GetCharacterFreeSpace(refCharacter,GOOD_GRAPES);
			n = MakeInt(1200/shClass);
			if(i>0) {
				if(i>=n) SetCharacterGoods(refCharacter,GOOD_GRAPES,n);
				else SetCharacterGoods(refCharacter,GOOD_GRAPES,i);
		// knippels
				i = GetCharacterFreeSpace(refCharacter,GOOD_KNIPPELS);
				n = MakeInt(600/shClass);
				if(i>0) 
				{
					if(i>=n) SetCharacterGoods(refCharacter,GOOD_KNIPPELS,n);
					else SetCharacterGoods(refCharacter,GOOD_KNIPPELS,i);
		// cannonballs
					i = GetCharacterFreeSpace(refCharacter,GOOD_BALLS);
					n = MakeInt(2400/shClass);
					if(i>0) 
					{
						if(i>=n) SetCharacterGoods(refCharacter,GOOD_BALLS,n);
						else SetCharacterGoods(refCharacter,GOOD_BALLS,i);
		//powder
						i = GetCharacterFreeSpace(refCharacter,GOOD_POWDER);
						n = MakeInt(1800/shClass);
						if(i>0)
						{
							if(i>=n) SetCharacterGoods(refCharacter,GOOD_POWDER,n);
							else SetCharacterGoods(refCharacter,GOOD_POWDER,i);
		//weapon
							i = GetCharacterFreeSpace(refCharacter,GOOD_WEAPON);
							n = MakeInt(500/shClass);
							if(i>0)
							{
								if(i>=n) SetCharacterGoods(refCharacter, GOOD_WEAPON, n);
								else SetCharacterGoods(refCharacter, GOOD_WEAPON, i);

							}
						}
//navy <--
					}
				}
			}
		}
	}
}

void SetBaseFellows(object refCharacter)
{
	aref tmpRef;

	makearef(tmpRef,refCharacter.Fellows.Companions);
	tmpRef.id1 = -1;
	tmpRef.id2 = -1;
	tmpRef.id3 = -1;

	makearef(tmpRef,refCharacter.Fellows.Passengers);
	tmpRef.Quantity = 0;
	tmpRef.id1 = -1;
	tmpRef.id2 = -1;
	tmpRef.id3 = -1;
	tmpRef.id4 = -1;
	tmpRef.id5 = -1;
	tmpRef.id6 = -1;
	tmpRef.id7 = -1;
	tmpRef.id8 = -1;
	tmpRef.id9 = -1;
	tmpRef.id10 = -1;
	tmpRef.id11 = -1;
	tmpRef.id12 = -1;
	tmpRef.id13 = -1;
	tmpRef.id14 = -1;
	tmpRef.id15 = -1;
	tmpRef.id16 = -1;
	tmpRef.id17 = -1;
	tmpRef.id18 = -1;
	tmpRef.id19 = -1;
	tmpRef.id20 = -1;

	makearef(tmpRef,refCharacter.Fellows.Passengers.Officers);
	tmpRef.id1 = -1;
	tmpRef.id2 = -1;
	tmpRef.id3 = -1;
}

// statistics utilite
void DoShipKilledStatistics(int killerCharacterIdx,int deadCharacterIdx)
{
	ref killer = GetCharacter(killerCharacterIdx);
	ref dead = GetCharacter(deadCharacterIdx);

	string attrName = Nations[sti(dead.nation)].Name;
	int oldValue = GetNationShipKilled(killer,attrName);
	killer.Statistics.KilledShip.Nation.(attrName) = oldValue+1;

	oldValue = GetClassShipKilled(GetCharacterShipClass(dead));
	attrName = "" + GetCharacterShipClass(dead);
	killer.Statistics.KilledShip.Class.(attrName) = oldValue+1;
}

void DoShipCaptureStatistics(int killerCharacterIdx,int captiveCharacterIdx)
{
	ref killer = GetCharacter(killerCharacterIdx);
	ref captive = GetCharacter(captiveCharacterIdx);

	string attrName = Nations[sti(captive.nation)].Name;
	int oldValue = GetNationShipCaptured(killer,attrName);
	killer.Statistics.CapturedShip.Nation.(attrName) = oldValue+1;

	oldValue = GetClassShipCaptured(killer,GetCharacterShipClass(captive));
	attrName = "" + GetCharacterShipClass(captive);
	killer.Statistics.CapturedShip.Class.(attrName) = oldValue+1;
}

int GetNationShipKilled(ref _refCharacter,string nation)
{
	if( CheckAttribute(_refCharacter,"Statistics.KilledShip.Nation." + nation) )
		return sti(_refCharacter.Statistics.KilledShip.Nation.(nation));
	return 0;
}
int GetClassShipKilled(ref _refCharacter,int classNum)
{
	string className = "" + classNum;
	if( CheckAttribute(_refCharacter,"Statistics.KilledShip.Class." + classNum) )
		return sti(_refCharacter.Statistics.KilledShip.Class.(className));
	return 0;
}

int GetNationShipCaptured(ref _refCharacter,string nation)
{
	if( CheckAttribute(_refCharacter,"Statistics.CapturedShip.Nation." + nation) )
		return sti(_refCharacter.Statistics.CapturedShip.Nation.(nation));
	return 0;
}
int GetClassShipCaptured(ref _refCharacter,int classNum)
{
	string className = "" + classNum;
	if( CheckAttribute(_refCharacter,"Statistics.CapturedShip.Class." + classNum) )
		return sti(_refCharacter.Statistics.CapturedShip.Class.(className));
	return 0;
}

// Items Utilite
int GetChrItemQuantity(ref _refCharacter)
{
	aref ar; makearef(ar,_refCharacter.items);
	return GetAttributesNum(ar);
}
bool GiveItem2Character(ref _refCharacter,string itemName)
{
	return TakeNItems(_refCharacter,itemName,1);
}
void TakeItemFromCharacter(ref _refCharacter,string itemName)
{
	TakeNItems(_refCharacter,itemName,-1);
}
//
void TakeItemFromCharacter_100(ref _refCharacter,string itemName)
{
	TakeNItems(_refCharacter,itemName, -100);
}
void TakeItemFromCharacter_10(ref _refCharacter,string itemName)
{
	TakeNItems(_refCharacter,itemName, -10);
}
//
bool CheckCharacterItem(ref _refCharacter,string itemName)
{
	if( CheckAttribute(_refCharacter,"Items."+itemName) && sti(_refCharacter.Items.(itemName))>0 )	return true;
	else	return false;
}
int GetCharacterItem(ref _refCharacter,string itemName)
{
	if(CheckAttribute(_refCharacter,"Items."+itemName))
	{
		return sti(_refCharacter.Items.(itemName));
	}
	return 0;
}
bool ReplaceItem(ref _refTakingCharacter,ref _refGivingCharacter,string itemName)
{
	bool retVal = CheckCharacterItem(_refGivingCharacter,itemName);
	if( TakeNItems(_refTakingCharacter,itemName,1) )
		TakeNItems(_refGivingCharacter,itemName,-1);
	return retVal;
}
bool TakeNItems(ref _refCharacter,string itemName, int n)
{
	int q;
	aref arItm;
	if( Items_FindItem(itemName,&arItm)<0 )
	{
		trace("WARNING!!! Item id = "+itemName+" not implemented");
		return false;
	}
	if( CheckAttribute(arItm,"gold") )
	{
		if( CheckAttribute(_refCharacter,"Money") )	q = sti(_refCharacter.Money);
		else q = 0;
		q += n*sti(arItm.gold);
		if(q<0) {q=0;}
		_refCharacter.Money = q;
		return true;
	}
	if( CheckAttribute(arItm,"price") && sti(arItm.price)==0 )
	{
		if(sti(_refCharacter.index)==GetMainCharacterIndex() && IsEntity(_refCharacter))
		{
			if(n>0)	{Log_SetStringToLog(XI_ConvertString("You take item"));}
			if(n<0)	{Log_SetStringToLog(XI_ConvertString("You give item"));}
			PlayStereoSound("interface\important_item.wav");
		}
		if( n>0 && IsOfficer(_refCharacter) || IsCompanion(_refCharacter) ) {
			AddMsgToCharacter(_refCharacter,MSGICON_GETITEM);
		}
	}
	q = GetCharacterItem(_refCharacter,itemName);
	if(q+n<=0) DeleteAttribute(_refCharacter,"Items."+itemName);
	else
	{
		if(q<=0 && GetChrItemQuantity(_refCharacter)>=MAX_ITEM_TAKE) return false;
		_refCharacter.Items.(itemName) = q+n;
	}
	return true;
}


//   
int FindFirstContrabandGoods(ref _refCharacter)
{
	int i;
	int curStoreIdx = GetCharacterCurrentStore(_refCharacter);
	if(curStoreIdx>=0)
	{
		_refCharacter.FindContrabandGoods.StoreIdx = curStoreIdx;
		for(i=0; i<GOODS_QUANTITY; i++)
		{
			if( GetStoreGoodsType(&Stores[curStoreIdx],i) == TRADE_TYPE_CONTRABAND_NAME )
			{
				if( GetSquadronGoods(_refCharacter,i)>0 )
				{
					_refCharacter.FindContrabandGoods.GoodsIdx = i;
					return i;
				}
			}
		}
		DeleteAttribute(_refCharacter,"FindContrabandGoods");
		return -1;
	}
	int curLocIdx = FindLocation(_refCharacter.location);
	if(curLocIdx<0) return -1;
	int curIslandIdx = GetIslandIdxByLocationIdx(curLocIdx);
	if(curIslandIdx<0) return -1;
	aref islRef; makearef(islRef,Islands[curIslandIdx].Trade.Contraband);
	int n;
	for(i=0;i<GetAttributesNum(islRef);i++)
	{
		n = sti(GetAttributeValue(GetAttributeN(islRef,0)));
		if( GetSquadronGoods(_refCharacter,n)>0 )
		{
			_refCharacter.FindContrabandGoods.IslandIdx = curIslandIdx;
			_refCharacter.FindContrabandGoods.GoodsIdx = i;
			return n;
		}
	}
	return -1;
}

int FindNextContrabandGoods(ref _refCharacter)
{
	int i,n;
	if(CheckAttribute(_refCharacter,"FindContrabandGoods.StoreIdx"))
	{
		if(CheckAttribute(_refCharacter,"FindContrabandGoods.GoodsIdx"))
		{
			int curStoreIdx = sti(_refCharacter.FindContrabandGoods.StoreIdx);
			if(curStoreIdx>=0)
			{
				for(i=sti(_refCharacter.FindContrabandGoods.GoodsIdx)+1; i<GOODS_QUANTITY; i++)
				{
					if( GetStoreGoodsType(&Stores[curStoreIdx],i) == TRADE_TYPE_CONTRABAND_NAME )
					{
						if( GetSquadronGoods(_refCharacter,i)>0 )
						{
							_refCharacter.FindContrabandGoods.GoodsIdx = i;
							return i;
						}
					}
				}
			}
		}
	}
	else
	{
		if(CheckAttribute(_refCharacter,"FindContrabandGoods.IslandIdx"))
		{
			if(CheckAttribute(_refCharacter,"FindContrabandGoods.GoodsIdx"))
			{
				int curIslandIdx = sti(_refCharacter.FindContrabandGoods.IslandIdx);
				if(curIslandIdx>=0)
				{
					int curGoodsNum = sti(_refCharacter.FindContrabandGoods.GoodsIdx) + 1;
					aref islRef; makearef(islRef,Islands[curIslandIdx].Trade.Contraband);
					for(i=curGoodsNum; i<GetAttributesNum(islRef); i++)
					{
						n = GetAttributeValue(GetAttributeN(islRef,i));
						if( GetSquadronGoods(_refCharacter,n)>0 )
						{
							_refCharacter.FindContrabandGoods.GoodsIdx = i;
							return n;
						}
					}
				}
			}
		}
	}
	DeleteAttribute(_refCharacter,"FindContrabandGoods");
	return -1;
}

int GetCharacterCurrentIsland(ref _refCharacter)
{
	int curLocNum = FindLocation(Characters[GetMainCharacterIndex()].location);
	if(curLocNum<0) return -1;
	return GetIslandIdxByLocationIdx(curLocNum);
}

int GetIslandIdxByLocationIdx(int locIdx)
{
	aref rootar,ar;
	makearef(rootar,Locations[0].IslandsList);
	for(int i=0; i<GetAttributesNum(rootar); i++)
	{
		ar = GetAttributeN(rootar,i);
		if( locIdx>=sti(ar.begin) && locIdx<=sti(ar.end) )
		{
			return FindIsland(GetAttributeName(ar));
		}
	}
	return -1;
}

int GetCharacterCurrentStore(ref _refCharacter)
{
	int i;
	int curLocNum = FindLocation(Characters[GetMainCharacterIndex()].location);
	if(curLocNum<0) return -1;

	if( CheckAttribute(&Locations[curLocNum],"fastreload") )
	{
		string locGroupId = Locations[curLocNum].fastreload;
		for(i=0; i<STORE_QUANTITY; i++)
		{
			if(Stores[i].group==locGroupId)
			{
				return i;
			}
		}
	}
	else
	{
		curLocNum = GetIslandIdxByLocationIdx(curLocNum);
		if(curLocNum<0)	{return -1;}
		for(i=0; i<STORE_QUANTITY; i++)
		{
			if(stores[i].Island==Islands[curLocNum].id)
			{
				return i;
			}
		}
	}

	return  -1;
}

int GetCurrentIslandGoodsPrice(int GoodsType)
{
	int curStoreIdx = GetCharacterCurrentStore(GetMainCharacter());
	if(curStoreIdx<0) return 0;
	return GetStoreGoodsPrice(&Stores[curStoreIdx],GoodsType,PRICE_TYPE_SELL,GetMainCharacter());
}

int GetCurrentLocationNation() 
{
	int curLocNum = FindLocation(Characters[GetMainCharacterIndex()].location);
	if(curLocNum<0) return -1;
	return GetLocationNation(&Locations[curLocNum]);
}

void SetRandomNameToCharacter(ref rCharacter)
{
	int iNation = sti(rCharacter.nation);
	if (iNation == -1) iNation = PIRATE;
	while (iNation == PIRATE) { iNation = rand(MAX_NATIONS - 1); }
	
	ref rNames, rLastNames;

	switch(iNation)
	{
		case ENGLAND:
			rNames = &sEnManNames;
			if (rCharacter.sex != "man") rNames = &sEnWomenNames;
			rLastNames = &sEnFamilies;
		break;
		case FRANCE:
			rNames = &sFrManNames;
			if (rCharacter.sex != "man") rNames = &sFrWomenNames;
			rLastNames = &sFrFamilies;
		break;
		case SPAIN:
			rNames = &sSpManNames;
			if (rCharacter.sex != "man") rNames = &sSpWomenNames;
			rLastNames = &sSpFamilies;
		break;
		case HOLLAND:
			rNames = &sHoManNames;
			if (rCharacter.sex != "man") rNames = &sHoWomenNames;
			rLastNames = &sHoFamilies;
		break;
		case PORTUGAL:
			rNames = &sPoManNames;
			if (rCharacter.sex != "man") rNames = &sPoWomenNames;
			rLastNames = &sPoFamilies;
		break;
	}

	rCharacter.name = GetRandSubString(rNames[rand(GetArraySize(rNames) - 2)]);
	rCharacter.lastname = GetRandSubString(rLastNames[rand(GetArraySize(rLastNames) - 2)]);
}

//=============================================================================
//  EQUIP SECTION
//=============================================================================
string FindCharacterItemByGroup(ref chref, string groupID)
{
	int i,n;
	ref refItm;

	for(i=ITEMS_QUANTITY-1; i>=0; i--)
	{
		refItm = &Items[i];
		if( !CheckAttribute(refItm,"groupID") ) continue;
		if(refItm.groupID!=groupID) continue;
		if( !CheckAttribute(chref,"items."+refItm.id) ) continue;
		if(groupID==GUN_ITEM_TYPE)
		{
			if( !CheckAttribute(refItm,"chargeQ") ) continue;
			n = sti(refItm.chargeQ);
			if(n<2) {return refItm.id;}
			if(n<4)
			{
				if( IsCharacterPerkOn(chref,"Gunman") ) {return refItm.id;}
				else continue;
			}
//boal -->
			//if( IsCharacterPerkOn(GetMainCharacter(),"GunProfessional") )	{return refItm.id;}
            if( IsCharacterPerkOn(chref,"GunProfessional") )	{return refItm.id;}
// boal <--
			continue;
		}
		return refItm.id;
	}
	return "";
}


bool IsEquipCharacterByItem(ref chref, string itemID)
{
	aref arEquip;
	makearef(arEquip,chref.equip);
	int q = GetAttributesNum(arEquip);
	for(int i=0; i<q; i++)
	{	if(GetAttributeValue(GetAttributeN(arEquip,i))==itemID) return true;
	}
	return false;
}

string GetCharacterEquipByGroup(ref chref, string groupID)
{
	if( CheckAttribute(chref,"equip."+groupID) ) return chref.equip.(groupID);
	return "";
}

void RemoveCharacterEquip(ref chref, string groupID)
{
	DeleteAttribute(chref,"equip."+groupID);
	SetEquipedItemToCharacter(chref,groupID,"");
}

void SetEquipedItemToCharacter(ref chref, string groupID, string itemID)
{
	object emptyItm;
	aref arItm;
	string modelName = "";
	makearef(arItm,emptyItm);
	int itemNum; // boal 23.01.2004

	if(itemID!="")
	{
		if( !CheckCharacterItem(chref,itemID) ) return;
		itemNum = Items_FindItem(itemID,&arItm);
	}

	switch(groupID)
	{
	case SPYGLASS_ITEM_TYPE:
		if(CheckAttribute(arItm,"id"))
		{
			setTelescopeInitParameters(&Telescope,arItm);
		}
	break;


	case CIRASS_ITEM_TYPE:
		if(chref.id == "Blaze0")
		{
			if(CheckAttribute(arItm, "model"))
			{
				chref.model = heroModel + arItm.model;
				chref.cuirassId = itemNum;
			}
			else
			{
				chref.model = heroModel;
				DeleteAttribute(chref, "cuirassId");
			}
		}
		else
		{
		// 
		}
		SendMessage(chref, "lss",   MSG_CHARACTER_SETMODEL, chref.model, chref.model.animation);
		SendMessage(chref, "ls",    MSG_CHARACTER_SETGUN,   chref.equip.gun);
		SendMessage(chref, "lsfll", MSG_CHARACTER_SETBLADE, chref.equip.blade, liveTime, colors, colore);
	break;

	case GUN_ITEM_TYPE:
		if(CheckAttribute(arItm,"model"))	{modelName = arItm.model;}
		SendMessage(chref,"ls",MSG_CHARACTER_SETGUN,modelName);
		if(CheckAttribute(arItm,"chargeQ"))
		{	LAi_GunSetChargeQuant(chref,sti(arItm.chargeQ));
		} else
		{	LAi_GunSetChargeQuant(chref,0);
		}
		if(CheckAttribute(arItm,"chargespeed") && stf(arItm.chargespeed)>0.0)
		{	LAi_GunSetChargeSpeed(chref,1.0/stf(arItm.chargespeed));
		} else
		{	LAi_GunSetChargeSpeed(chref,0.0);
		}
		if(CheckAttribute(arItm,"dmg_min"))
		{	LAi_GunSetDamageMin(chref,stf(arItm.dmg_min));
		} else
		{	LAi_GunSetDamageMin(chref,0.0);
		}
		if(CheckAttribute(arItm,"dmg_max"))
		{	LAi_GunSetDamageMax(chref,stf(arItm.dmg_max));
		} else
		{	LAi_GunSetDamageMax(chref,0.0);
		}
		if(CheckAttribute(arItm,"accuracy"))
		{	LAi_GunSetAccuracy(chref,stf(arItm.accuracy)*0.01);
		} else
		{	LAi_GunSetAccuracy(chref,0.0);
		}
	break;

	case BLADE_ITEM_TYPE:
		float liveTime = 0.1;
		int colors = argb(64, 64, 64, 64);
		int colore = argb(0, 32, 32, 32);
		if(CheckAttribute(arItm,"model"))	{modelName = arItm.model;}
		if(CheckAttribute(arItm, "blade.time"))	{liveTime = stf(arItm.blade.time);}
		if(CheckAttribute(arItm, "blade.colorstart"))	{colors = sti(arItm.blade.colorstart);}
		if(CheckAttribute(arItm, "blade.colorend"))	{colore = sti(arItm.blade.colorend);}
		SendMessage(chref, "lsfll", MSG_CHARACTER_SETBLADE, modelName, liveTime, colors, colore);
		if(CheckAttribute(arItm,"dmg_min"))
		{	LAi_BladeSetDamageMin(chref,stf(arItm.dmg_min));
		} else
		{	LAi_BladeSetDamageMin(chref,0.0);
		}
		if(CheckAttribute(arItm,"dmg_max"))
		{	LAi_BladeSetDamageMax(chref,stf(arItm.dmg_max));
		} else
		{	LAi_BladeSetDamageMax(chref,0.0);
		}
		if(CheckAttribute(arItm,"piercing"))
		{	LAi_BladeSetPiercing(chref,stf(arItm.piercing)*0.01);
		} else
		{	LAi_BladeSetPiercing(chref,0.0);
		}
		if(CheckAttribute(arItm,"block"))
		{	LAi_BladeSetBlock(chref,stf(arItm.block)*0.01);
		} else
		{	LAi_BladeSetBlock(chref,0.0);
		}
	break;
	}
}

void EquipCharacterByItem(ref chref, string itemID)
{
	aref arItm;

	if( !CheckCharacterItem(chref, itemID) ) return;
	if( Items_FindItem(itemID, &arItm)<0 )	return;
	if( !CheckAttribute(arItm, "groupID") ) return;

	string groupName = arItm.groupID;
	string oldItemID = GetCharacterEquipByGroup(chref, groupName);
	if(oldItemID==itemID) return;
	chref.equip.(groupName) = itemID;

	if(IsEntity(chref))
	{	SetEquipedItemToCharacter(chref, groupName, itemID);
	}
	if(groupName==GUN_ITEM_TYPE && sti(chref.index)==GetMainCharacterIndex())
	{	LAi_GunSetUnload(chref);
	}
}

void ExecuteCharacterEquip(ref chref)
{
	stmp = GetCharacterEquipByGroup(chref,BLADE_ITEM_TYPE);
	if(stmp!="")	{SetEquipedItemToCharacter(chref, BLADE_ITEM_TYPE, stmp);}
	string stmp = GetCharacterEquipByGroup(chref,GUN_ITEM_TYPE);
	if(stmp!="")	{SetEquipedItemToCharacter(chref, GUN_ITEM_TYPE, stmp);}
}

bool IsCanEquiping(ref chref, string equiping_group)
{
	if( CheckAttribute(chref,"equip.disabled_group."+equiping_group)
		&& sti(chref.equip.disabled_group.(equiping_group))==true ) return false;
	return true;
}

void EnableEquip(ref chref, string equiping_group, bool enable)
{
	if(enable)
	{	if(equiping_group=="")
		{	DeleteAttribute(chref,"equip.disabled_group");
		}
		else
		{	DeleteAttribute(chref,"equip.disabled_group."+equiping_group);
		}
	}
	else
	{	if(equiping_group=="")
		{
			string stmp;
			stmp = GUN_ITEM_TYPE;		chref.equip.disabled_group.(stmp) = true;
			stmp = BLADE_ITEM_TYPE;		chref.equip.disabled_group.(stmp) = true;
			stmp = SPYGLASS_ITEM_TYPE;	chref.equip.disabled_group.(stmp) = true;
		}
		else
		{
			chref.equip.disabled_group.(equiping_group) = true;
		}
	}
}

int ChangeCharacterReputation(ref chref, int incr)
{
	int prevVal = REPUTATION_NEUTRAL;
	if( CheckAttribute(chref,"reputation") )	prevVal = sti(chref.reputation);

	int newVal = prevVal + incr;
	if(newVal<REPUTATION_MIN) newVal = REPUTATION_MIN;
	if(newVal>REPUTATION_MAX) newVal = REPUTATION_MAX;
	chref.reputation = newVal;

	if( sti(chref.index) != GetMainCharacterIndex() ) return newVal;

	string prevName = GetReputationName(prevVal);
	string newName = GetReputationName(newVal);
	if(prevName!=newName)
	{
		string outString = XI_ConvertString("Your reputation")+" ";
		if(incr>0)	{outString+=XI_ConvertString("increase");}
		else	{outString+=XI_ConvertString("decrease");}
		outString += " "+XI_ConvertString("to")+" "+XI_ConvertString(newName);
		Log_SetStringToLog(outString);
	}

	return newVal;
}

bool Character_IsAbordageEnable(ref rCharacter)
{
	if (CheckAttribute(rCharacter, "Abordage.Enable")) { return sti(rCharacter.Abordage.Enable); }
	return true;
}

void Character_SetAbordageEnable(ref rCharacter, bool bEnable)
{
	rCharacter.Abordage.Enable = bEnable;
}

void Character_SetCompanionEnemyEnable(ref rCharacter, bool bEnable)
{
	rCharacter.CompanionEnemyEnable = bEnable;
}

void AddMsgToCharacter(ref chref, int nMsg)
{
	string msgName = "msg"+nMsg;
	bool bStartEvent = !CheckAttribute(chref,"MessageIcons."+msgName);
	chref.MessageIcons.(msgName).pic = nMsg;
	chref.MessageIcons.(msgName) = MSGICON_ACTIVE_TIME;
	if(bStartEvent) PostEvent("evnt_MsgIconTick",1000,"ll",nMsg,sti(chref.index));
}

void DelMsgFromCharacter(ref chref, int nMsg)
{
	DeleteAttribute(chref,"MessageIcons.msg"+nMsg);
}

void proc_MsgIconTick()
{
	int nMsg = GetEventData();
	int chrIdx = GetEventData();
	if(DialogRun!=0) {
		PostEvent("evnt_MsgIconTick",1000,"ll",nMsg,chrIdx);
		return;
	}
	ref chref = GetCharacter(chrIdx);
	string msgName = "msg"+nMsg;
	int nTime = 0;

	if( CheckAttribute(chref,"MessageIcons."+msgName) )
	{
		nTime = sti(chref.MessageIcons.(msgName));
		if(nTime>0)
		{
			chref.MessageIcons.(msgName) = nTime-1;
			PostEvent("evnt_MsgIconTick",1000,"ll",nMsg,chrIdx);
			return;
		}
		DelMsgFromCharacter(chref,nMsg);
	}
}
